/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","moment","app/core/utils/kbn","./query_builder","./index_pattern","./elastic_response","./query_ctrl","./directives"],function(a,b,c,d,e,f,g){"use strict";var h=a.module("grafana.services");h.factory("ElasticDatasource",["$q","backendSrv","templateSrv","timeSrv",function(d,h,i,j){function k(a){this.type="elasticsearch",this.basicAuth=a.basicAuth,this.withCredentials=a.withCredentials,this.url=a.url,this.name=a.name,this.index=a.index,this.timeField=a.jsonData.timeField,this.esVersion=a.jsonData.esVersion,this.indexPattern=new f(a.index,a.jsonData.interval),this.queryBuilder=new e({timeField:this.timeField,esVersion:this.esVersion})}return k.prototype._request=function(a,b,c){var d={url:this.url+"/"+b,method:a,data:c};return(this.basicAuth||this.withCredentials)&&(d.withCredentials=!0),this.basicAuth&&(d.headers={Authorization:this.basicAuth}),h.datasourceRequest(d)},k.prototype._get=function(a){return this._request("GET",this.indexPattern.getIndexForToday()+a).then(function(a){return a.data})},k.prototype._post=function(a,b){return this._request("POST",a,b).then(function(a){return a.data})},k.prototype.annotationQuery=function(d){var e=d.annotation,f=e.timeField||"@timestamp",g=e.query||"*",h=e.tagsField||"tags",j=e.titleField||"desc",k=e.textField||null,l={};l[f]={from:d.range.from.valueOf(),to:d.range.to.valueOf()};var m=i.replace(g),n={bool:{must:[{range:l}]}},o={bool:{should:[{query_string:{query:m}}]}},p={fields:[f,"_source"],query:{filtered:{query:o,filter:n}},size:1e4},q={search_type:"query_then_fetch",ignore_unavailable:!0};q.index=e.index?e.index:this.indexPattern.getIndexList(d.range.from,d.range.to);var r=a.toJson(q)+"\n"+a.toJson(p)+"\n";return this._post("_msearch",r).then(function(a){for(var d=[],g=a.responses[0].hits.hits,i=function(a,c){if(c){for(var d=c.split("."),e=a,f=0;f<d.length;f++)if(e=e[d[f]],!e)return console.log("could not find field in annotation: ",c),"";return b.isArray(e)&&(e=e.join(", ")),e}},l=0;l<g.length;l++){var m=g[l]._source,n=g[l].fields,o=m[f];(b.isString(n[f])||b.isNumber(n[f]))&&(o=n[f]);var p={annotation:e,time:c.utc(o).valueOf(),title:i(m,j),tags:i(m,h),text:i(m,k)};d.push(p)}return d})},k.prototype.testDatasource=function(){return this._get("/_stats").then(function(){return{status:"success",message:"Data source is working",title:"Success"}},function(a){return a.data&&a.data.error?{status:"error",message:a.data.error,title:"Error"}:{status:"error",message:a.status,title:"Error"}})},k.prototype.getQueryHeader=function(b,c,d){var e={search_type:b,ignore_unavailable:!0};return e.index=this.indexPattern.getIndexList(c,d),a.toJson(e)},k.prototype.query=function(b){for(var c,e="",f=[],h=0;h<b.targets.length;h++)if(c=b.targets[h],!c.hide){var j=this.queryBuilder.build(c),k=a.toJson(j),l=a.toJson(c.query||"*");l=l.substr(1,l.length-2),k=k.replace("$lucene_query",l);var m=0===j.size?"count":"query_then_fetch",n=this.getQueryHeader(m,b.range.from,b.range.to);e+=n+"\n",e+=k+"\n",f.push(c)}return 0===f.length?d.when([]):(e=e.replace(/\$interval/g,b.interval),e=e.replace(/\$timeFrom/g,b.range.from.valueOf()),e=e.replace(/\$timeTo/g,b.range.to.valueOf()),e=i.replace(e,b.scopedVars),this._post("_msearch",e).then(function(a){return new g(f,a).getTimeSeries()}))},k.prototype.getFields=function(a){return this._get("/_mapping").then(function(c){var d={},e={"float":"number","double":"number",integer:"number","long":"number",date:"date",string:"string"};for(var f in c){var g=c[f],h=g.mappings;if(h)for(var i in h){var j=h[i].properties;for(var k in j){var l=j[k];a.type&&e[l.type]!==a.type||l.type&&"_"!==k[0]&&(d[k]={text:k,type:l.type})}}}return b.map(d,function(a){return a})})},k.prototype.getTerms=function(c){var d=j.timeRange(),e=this.getQueryHeader("count",d.from,d.to),f=a.toJson(this.queryBuilder.getTermsQuery(c));return f=f.replace("$lucene_query",c.query||"*"),f=f.replace(/\$timeFrom/g,d.from.valueOf()),f=f.replace(/\$timeTo/g,d.to.valueOf()),f=e+"\n"+f+"\n",this._post("/_msearch?search_type=count",f).then(function(a){var c=a.responses[0].aggregations[1].buckets;return b.map(c,function(a){return{text:a.key,value:a.key}})})},k.prototype.metricFindQuery=function(b){return b=i.replace(b),b=a.fromJson(b),b?"fields"===b.find?this.getFields(b):"terms"===b.find?this.getTerms(b):void 0:d.when([])},k.prototype.getDashboard=function(b){return this._get("/dashboard/"+b).then(function(b){return a.fromJson(b._source.dashboard)})},k.prototype.searchDashboards=function(){var a={query:{query_string:{query:"*"}},size:1e4,sort:["_uid"]};return this._post(this.index+"/dashboard/_search",a).then(function(a){if(b.isUndefined(a.hits))return{dashboards:[],tags:[]};for(var c=a.hits.hits,d={dashboards:[]},e=0,f=c.length;f>e;e++){var g=c[e];d.dashboards.push({id:g._id,title:g._source.title,tags:g._source.tags})}return d})},k}])});