/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","jquery","app/core/config","app/core/utils/datemath","./directives","./query_ctrl","./func_editor","./add_graphite_func"],function(a,b,c,d,e){"use strict";var f=a.module("grafana.services");f.factory("GraphiteDatasource",["$q","backendSrv","templateSrv",function(a,d,f){function g(a){this.basicAuth=a.basicAuth,this.url=a.url,this.name=a.name,this.cacheTimeout=a.cacheTimeout,this.withCredentials=a.withCredentials,this.render_method=a.render_method||"POST"}return g.prototype.query=function(b){try{var c={from:this.translateTime(b.rangeRaw.from,!1),until:this.translateTime(b.rangeRaw.to,!0),targets:b.targets,format:b.format,cacheTimeout:b.cacheTimeout||this.cacheTimeout,maxDataPoints:b.maxDataPoints},d=this.buildGraphiteParams(c,b.scopedVars);if("png"===b.format)return a.when(this.url+"/render?"+d.join("&"));var e={method:this.render_method,url:"/render"};return"GET"===e.method?e.url=e.url+"?"+d.join("&"):(e.data=d.join("&"),e.headers={"Content-Type":"application/x-www-form-urlencoded"}),this.doGraphiteRequest(e).then(this.convertDataPointsToMs)}catch(f){return a.reject(f)}},g.prototype.convertDataPointsToMs=function(a){if(!a||!a.data)return[];for(var b=0;b<a.data.length;b++)for(var c=a.data[b],d=0;d<c.datapoints.length;d++)c.datapoints[d][1]*=1e3;return a},g.prototype.annotationQuery=function(a){if(a.annotation.target){var b=f.replace(a.annotation.target),c={rangeRaw:a.rangeRaw,targets:[{target:b}],format:"json",maxDataPoints:100};return this.query(c).then(function(b){for(var c=[],d=0;d<b.data.length;d++)for(var e=b.data[d],f=0;f<e.datapoints.length;f++){var g=e.datapoints[f];g[0]&&c.push({annotation:a.annotation,time:g[1],title:e.target})}return c})}var d=f.replace(a.annotation.tags);return this.events({range:a.rangeRaw,tags:d}).then(function(b){for(var c=[],d=0;d<b.data.length;d++){var e=b.data[d];c.push({annotation:a.annotation,time:1e3*e.when,title:e.what,tags:e.tags,text:e.data})}return c})},g.prototype.events=function(b){try{var c="";return b.tags&&(c="&tags="+b.tags),this.doGraphiteRequest({method:"GET",url:"/events/get_data?from="+this.translateTime(b.range.from,!1)+"&until="+this.translateTime(b.range.to,!0)+c})}catch(d){return a.reject(d)}},g.prototype.translateTime=function(a,c){if(b.isString(a)){if("now"===a)return"now";if(a.indexOf("now-")>=0&&-1===a.indexOf("/"))return a=a.substring(3),a=a.replace("m","min"),a=a.replace("M","mon");a=e.parse(a,c)}return c?a.get("s")&&a.add(1,"m"):c===!1&&a.get("s")&&a.subtract(1,"m"),a.unix()},g.prototype.metricFindQuery=function(c){var d;try{d=encodeURIComponent(f.replace(c))}catch(e){return a.reject(e)}return this.doGraphiteRequest({method:"GET",url:"/metrics/find/?query="+d}).then(function(a){return b.map(a.data,function(a){return{text:a.text,expandable:a.expandable?!0:!1}})})},g.prototype.testDatasource=function(){return this.metricFindQuery("*").then(function(){return{status:"success",message:"Data source is working",title:"Success"}})},g.prototype.listDashboards=function(a){return this.doGraphiteRequest({method:"GET",url:"/dashboard/find/",params:{query:a||""}}).then(function(a){return a.data.dashboards})},g.prototype.loadDashboard=function(a){return this.doGraphiteRequest({method:"GET",url:"/dashboard/load/"+encodeURIComponent(a)})},g.prototype.doGraphiteRequest=function(a){return(this.basicAuth||this.withCredentials)&&(a.withCredentials=!0),this.basicAuth&&(a.headers=a.headers||{},a.headers.Authorization=this.basicAuth),a.url=this.url+a.url,a.inspect={type:"graphite"},d.datasourceRequest(a)},g.prototype._seriesRefLetters="ABCDEFGHIJKLMNOPQRSTUVWXYZ",g.prototype.buildGraphiteParams=function(a,d){function e(a){return a.replace("m","min").replace("M","mon")}function g(a,b){return m[b]}var h,i,j,k=["from","until","rawData","format","maxDataPoints","cacheTimeout"],l=[],m={},n=/\#([A-Z])/g,o=/'(\d+)m'/gi;for("png"!==a.format&&(a.format="json"),j=0;j<a.targets.length;j++)h=a.targets[j],h.target&&(h.refId||(h.refId=this._seriesRefLetters[j]),i=f.replace(h.target,d),i=i.replace(o,e),m[h.refId]=i);for(j=0;j<a.targets.length;j++)h=a.targets[j],h.target&&(i=m[h.refId],i=i.replace(n,g),m[h.refId]=i,h.hide||l.push("target="+encodeURIComponent(i)));return b.each(a,function(a,b){-1!==c.inArray(b,k)&&a&&l.push(b+"="+encodeURIComponent(a))}),l},g}])});