/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","app/core/utils/datemath","./influx_series","./influx_query","./directives","./query_ctrl"],function(a,b,c,d,e){"use strict";var f=a.module("grafana.services");f.factory("InfluxDatasource",["$q","backendSrv","templateSrv",function(a,f,g){function h(a){this.type="influxdb",this.urls=b.map(a.url.split(","),function(a){return a.trim()}),this.username=a.username,this.password=a.password,this.name=a.name,this.database=a.database,this.basicAuth=a.basicAuth,this.supportAnnotations=!0,this.supportMetrics=!0}function i(a){var b=j(a.rangeRaw.from,!1),c=j(a.rangeRaw.to,!0),d="s"===b[b.length-1];return"now()"!==c||d?"time > "+b+" and time < "+c:"time > "+b}function j(a,d){if(b.isString(a)){if("now"===a)return"now()";var e=/^now-(\d+)([d|h|m|s])$/.exec(a);if(e){var f=parseInt(e[1]),g=e[2];return"now() - "+f+g}a=c.parse(a,d)}return(a.valueOf()/1e3).toFixed(0)+"s"}return h.prototype.query=function(a){var c,f,h=i(a),j=[],k=b.map(a.targets,function(b){if(b.hide)return[];j.push(b);var c=new e(b),d=c.render();return d=d.replace(/\$interval/g,b.interval||a.interval)}).join("\n");return k=k.replace(/\$timeFilter/g,h),k=g.replace(k,a.scopedVars),this._seriesQuery(k).then(function(b){if(!b||!b.results)return[];var e=[];for(c=0;c<b.results.length;c++){var h=b.results[c];if(h&&h.series){var i=j[c],k=i.alias;k&&(k=g.replace(i.alias,a.scopedVars));var l=new d({series:b.results[c].series,alias:k});switch(i.resultFormat){case"table":e.push(l.getTable());break;default:var m=l.getTimeSeries();for(f=0;f<m.length;f++)e.push(m[f])}}}return{data:e}})},h.prototype.annotationQuery=function(a){var b=i({rangeRaw:a.rangeRaw}),c=a.annotation.query.replace("$timeFilter",b);return c=g.replace(c),this._seriesQuery(c).then(function(b){if(!b||!b.results||!b.results[0])throw{message:"No results in response from InfluxDB"};return new d({series:b.results[0].series,annotation:a.annotation}).getAnnotations()})},h.prototype.metricFindQuery=function(c){var d;try{d=g.replace(c)}catch(e){return a.reject(e)}return this._seriesQuery(d).then(function(a){if(!a||0===a.results.length)return[];var d=a.results[0];if(!d.series)return[];var e=d.series[0];if(0===c.indexOf("SHOW MEASUREMENTS"))return b.map(e.values,function(a){return{text:a[0],expandable:!0}});var f=b.flatten(e.values);return b.map(f,function(a){return{text:a,expandable:!0}})})},h.prototype._seriesQuery=function(a){return this._influxRequest("GET","/query",{q:a,epoch:"ms"})},h.prototype.testDatasource=function(){return this.metricFindQuery("SHOW MEASUREMENTS LIMIT 1").then(function(){return{status:"success",message:"Data source is working",title:"Success"}})},h.prototype._influxRequest=function(a,c,d){var e=this,g=e.urls.shift();e.urls.push(g);var h={u:e.username,p:e.password};e.database&&(h.db=e.database),"GET"===a&&(b.extend(h,d),d=null);var i={method:a,url:g+c,params:h,data:d,precision:"ms",inspect:{type:"influxdb"}};return i.headers=i.headers||{},e.basicAuth&&(i.headers.Authorization=e.basicAuth),f.datasourceRequest(i).then(function(a){return a.data},function(a){if(0!==a.status||a.status>=300)throw a.data&&a.data.error?{message:"InfluxDB Error Response: "+a.data.error,data:a.data,config:a.config}:{message:"InfluxDB Error: "+a.message,data:a.data,config:a.config}})},h}])});