/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","./query_builder","./influx_query","./query_part","./query_part_editor"],function(a,b,c,d,e){"use strict";var f=a.module("grafana.controllers");f.controller("InfluxQueryCtrl",["$scope","templateSrv","$q","uiSegmentSrv",function(f,g,h,i){f.init=function(){f.target&&(f.target=f.target,f.queryModel=new d(f.target),f.queryBuilder=new c(f.target),f.groupBySegment=i.newPlusButton(),f.resultFormats=[{text:"Time series",value:"time_series"},{text:"Table",value:"table"}],f.measurementSegment=f.target.measurement?i.newSegment(f.target.measurement):i.newSelectMeasurement(),f.tagSegments=[],b.each(f.target.tags,function(a){a.operator||(a.operator=/^\/.*\/$/.test(a.value)?"=~":"="),a.condition&&f.tagSegments.push(i.newCondition(a.condition)),f.tagSegments.push(i.newKey(a.key)),f.tagSegments.push(i.newOperator(a.operator)),f.tagSegments.push(i.newKeyValue(a.value))}),f.fixTagSegments(),f.buildSelectMenu(),f.removeTagFilterSegment=i.newSegment({fake:!0,value:"-- remove tag filter --"}))},f.buildSelectMenu=function(){var a=e.getCategories();f.selectMenu=b.reduce(a,function(a,c,d){var e={text:d};return e.submenu=b.map(c,function(a){return{text:a.type,value:a.type}}),a.push(e),a},[])},f.getGroupByOptions=function(){var a=f.queryBuilder.buildExploreQuery("TAG_KEYS");return f.datasource.metricFindQuery(a).then(function(a){var c=[];return f.queryModel.hasFill()||c.push(i.newSegment({value:"fill(null)"})),f.queryModel.hasGroupByTime()||c.push(i.newSegment({value:"time($interval)"})),b.each(a,function(a){c.push(i.newSegment({value:"tag("+a.text+")"}))}),c}).then(null,f.handleQueryError)},f.groupByAction=function(){f.queryModel.addGroupBy(f.groupBySegment.value);var a=i.newPlusButton();f.groupBySegment.value=a.value,f.groupBySegment.html=a.html,f.get_data()},f.removeGroupByPart=function(a,b){f.queryModel.removeGroupByPart(a,b),f.get_data()},f.addSelectPart=function(a,b,c){f.queryModel.addSelectPart(a,c.value),f.get_data()},f.removeSelectPart=function(a,b){f.queryModel.removeSelectPart(a,b),f.get_data()},f.selectPartUpdated=function(){f.get_data()},f.fixTagSegments=function(){var a=f.tagSegments.length,b=f.tagSegments[Math.max(a-1,0)];b&&"plus-button"===b.type||f.tagSegments.push(i.newPlusButton())},f.measurementChanged=function(){f.target.measurement=f.measurementSegment.value,f.get_data()},f.toggleQueryMode=function(){f.target.rawQuery=!f.target.rawQuery},f.getMeasurements=function(){var a=f.queryBuilder.buildExploreQuery("MEASUREMENTS");return f.datasource.metricFindQuery(a).then(f.transformToSegments(!0),f.handleQueryError)},f.getPartOptions=function(a){if("field"===a.def.type){var b=f.queryBuilder.buildExploreQuery("FIELDS");return f.datasource.metricFindQuery(b).then(f.transformToSegments(!0),f.handleQueryError)}if("tag"===a.def.type){var c=f.queryBuilder.buildExploreQuery("TAG_KEYS");return f.datasource.metricFindQuery(c).then(f.transformToSegments(!0),f.handleQueryError)}},f.handleQueryError=function(a){return f.parserError=a.message||"Failed to issue metric query",[]},f.transformToSegments=function(a){return function(c){var d=b.map(c,function(a){return i.newSegment({value:a.text,expandable:a.expandable})});return a&&b.each(g.variables,function(a){d.unshift(i.newSegment({type:"template",value:"/$"+a.name+"$/",expandable:!0}))}),d}},f.getTagsOrValues=function(b,c){if("condition"===b.type)return h.when([i.newSegment("AND"),i.newSegment("OR")]);if("operator"===b.type){var d=f.tagSegments[c+1].value;return h.when(/^\/.*\/$/.test(d)?i.newOperators(["=~","!~"]):i.newOperators(["=","<>","<",">"]))}var e,g;return"key"===b.type||"plus-button"===b.type?(e=f.queryBuilder.buildExploreQuery("TAG_KEYS"),g=!1):"value"===b.type&&(e=f.queryBuilder.buildExploreQuery("TAG_VALUES",f.tagSegments[c-2].value),g=!0),f.datasource.metricFindQuery(e).then(f.transformToSegments(g)).then(function(c){return"key"===b.type&&c.splice(0,0,a.copy(f.removeTagFilterSegment)),c}).then(null,f.handleQueryError)},f.getFieldSegments=function(){var a=f.queryBuilder.buildExploreQuery("FIELDS");return f.datasource.metricFindQuery(a).then(f.transformToSegments(!1)).then(null,f.handleQueryError)},f.getTagOptions=function(){},f.setFill=function(a){f.target.fill=a,f.get_data()},f.tagSegmentUpdated=function(a,b){f.tagSegments[b]=a,a.value===f.removeTagFilterSegment.value?(f.tagSegments.splice(b,3),0===f.tagSegments.length?f.tagSegments.push(i.newPlusButton()):f.tagSegments.length>2&&(f.tagSegments.splice(Math.max(b-1,0),1),"plus-button"!==f.tagSegments[f.tagSegments.length-1].type&&f.tagSegments.push(i.newPlusButton()))):("plus-button"===a.type&&(b>2&&f.tagSegments.splice(b,0,i.newCondition("AND")),f.tagSegments.push(i.newOperator("=")),f.tagSegments.push(i.newFake("select tag value","value","query-segment-value")),a.type="key",a.cssClass="query-segment-key"),b+1===f.tagSegments.length&&f.tagSegments.push(i.newPlusButton())),f.rebuildTargetTagConditions()},f.rebuildTargetTagConditions=function(){var a=[],c=0,d="";b.each(f.tagSegments,function(b,e){"key"===b.type?(0===a.length&&a.push({}),a[c].key=b.value):"value"===b.type?(d=f.getTagValueOperator(b.value,a[c].operator),d&&(f.tagSegments[e-1]=i.newOperator(d),a[c].operator=d),a[c].value=b.value):"condition"===b.type?(a.push({condition:b.value}),c+=1):"operator"===b.type&&(a[c].operator=b.value)}),f.target.tags=a,f.$parent.get_data()},f.getTagValueOperator=function(a,b){return"=~"!==b&&"!~"!==b&&/^\/.*\/$/.test(a)?"=~":"=~"!==b&&"!~"!==b||!/^(?!\/.*\/$)/.test(a)?void 0:"="},f.init()}])});