/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","app/core/utils/datemath","app/core/utils/kbn","./queryCtrl","./directives"],function(a,b,c,d){"use strict";var e=a.module("grafana.services");e.factory("KairosDBDatasource",["$q","backendSrv","templateSrv",function(e,f,g){function h(a){this.type=a.type,this.url=a.url,this.name=a.name,this.supportMetrics=!0}function i(a){if(a.data.errors&&!b.isEmpty(a.data.errors)){var c={message:a.data.errors[0]};return e.reject(c)}return e.reject(a)}function j(a,c){var d=[],e=0;return b.each(c.data.queries,function(c){b.each(c.results,function(c){var f=a[e].alias,g=" ( ";b.each(c.group_by,function(a){"tag"===a.name?b.each(a.group,function(a,b){g+=b+"="+a+" "}):"value"===a.name?g+="value_group="+a.group.group_number+" ":"time"===a.name&&(g+="time_group="+a.group.group_number+" ")}),g+=") "," ( ) "!==g&&(f+=g);for(var h=[],i=0;i<c.values.length;i++){var j=Math.floor(c.values[i][0]),k=c.values[i][1];h[i]=[k,j]}a[e].exouter&&(h=new n(h,10)),d.push({target:f,datapoints:h})}),e++}),{data:b.flatten(d)}}function k(c,d){if(!d.metric||d.hide)return null;var e={name:g.replace(d.metric)};return e.aggregators=[],"(NONE)"!==d.downsampling&&(void 0===d.downsampling&&(d.downsampling="avg",d.sampling="10s"),e.aggregators.push({name:d.downsampling,align_sampling:!0,align_start_time:!0,sampling:h.prototype.convertToKairosInterval(d.sampling||c.interval)})),d.horizontalAggregators&&b.each(d.horizontalAggregators,function(a){var b={name:a.name};a.sampling_rate&&(b.sampling=h.prototype.convertToKairosInterval(a.sampling_rate),b.align_sampling=!0,b.align_start_time=!0),a.unit&&(b.unit=a.unit+"s"),a.factor&&"div"===a.name?b.divisor=a.factor:a.factor&&"scale"===a.name&&(b.factor=a.factor),a.percentile&&(b.percentile=a.percentile),e.aggregators.push(b)}),b.isEmpty(e.aggregators)&&delete e.aggregators,d.tags&&(e.tags=a.copy(d.tags),b.forOwn(e.tags,function(a,c){e.tags[c]=b.map(a,function(a){return g.replace(a)})})),(d.groupByTags||d.nonTagGroupBys)&&(e.group_by=[],d.groupByTags&&e.group_by.push({name:"tag",tags:b.map(a.copy(d.groupByTags),function(a){return g.replace(a)})}),d.nonTagGroupBys&&b.each(d.nonTagGroupBys,function(b){var c=a.copy(b);"time"===c.name&&(c.range_size=h.prototype.convertToKairosInterval(c.range_size)),e.group_by.push(c)})),e}function l(a,d,e){var f;if(b.isString(a)){if("now"===a)return;if(a.indexOf("now-")>=0&&-1===a.indexOf("/")){a=a.substring(4),f=e+"_relative";var g=/(\d+)\s*(\D+)/,h=g.exec(a);if(h){var i=h[1],j=h[2];return void(d[f]={value:i,unit:m(j)})}return void console.log("Unparseable date",a)}a=c.parse(a,"end"===e)}f=e+"_absolute",d[f]=a.valueOf()}function m(a){switch(a){case"ms":return"milliseconds";case"s":return"seconds";case"m":return"minutes";case"h":return"hours";case"d":return"days";case"w":return"weeks";case"M":return"months";case"y":return"years";default:return console.log("Unknown unit ",a),""}}function n(a,b){var c=a,d=c.length;if(3>=d)return c;var e=d-1,f=Math.abs((c[1][0]-c[0][0])/c[0][0]),g=Math.abs((c[1][0]-c[2][0])/c[2][0]);f>=b&&b>g&&(c[0][0]=c[1][0]),f=Math.abs((c[e-1][0]-c[e-2][0])/c[e-2][0]),g=Math.abs((c[e-1][0]-c[e][0])/c[e][0]),f>=b&&b>g&&(c[e][0]=c[e-1][0]);for(var h=1;d-1>h;h++)f=Math.abs((c[h][0]-c[h-1][0])/c[h-1][0]),g=Math.abs((c[h][0]-c[h+1][0])/c[h+1][0]),f>=b&&g>=b&&(c[h][0]=(c[h-1][0]+c[h+1][0])/2);return c}return h.prototype.query=function(a){var c=a.rangeRaw.from,d=a.rangeRaw.to,f=b.compact(b.map(a.targets,b.partial(k,a))),g=b.compact(b.map(a.targets,function(a){var b=a.alias;return("undefined"==typeof a.alias||""===a.alias)&&(b=a.metric),a.hide?null:{alias:b,exouter:a.exOuter}})),h=b.partial(j,g);if(b.isEmpty(f)){var l=e.defer();return l.resolve({data:[]}),l.promise}return this.performTimeSeriesQuery(f,c,d).then(h,i)},h.prototype.performTimeSeriesQuery=function(a,b,c){var d={metrics:a,cache_time:0};l(b,d,"start"),l(c,d,"end");var e={method:"POST",url:this.url+"/api/v1/datapoints/query",data:d};return f.datasourceRequest(e)},h.prototype._performMetricSuggestQuery=function(a){var c={url:this.url+"/api/v1/metricnames",method:"GET"};return f.datasourceRequest(c).then(function(c){if(!c.data)return e.when([]);var d=[];return b.each(c.data.results,function(b){b.indexOf(a)>=0&&d.push(b)}),d})},h.prototype._performMetricKeyLookup=function(a){if(!a)return e.when([]);var c={method:"POST",url:this.url+"/api/v1/datapoints/query/tags",data:{metrics:[{name:a}],cache_time:0,start_absolute:0}};return f.datasourceRequest(c).then(function(a){if(!a.data)return e.when([]);var c=[];return b.each(a.data.queries[0].results[0].tags,function(a,b){-1===c.indexOf(b)&&c.push(b)}),c})},h.prototype._performMetricKeyValueLookup=function(a,b){if(!a||!b)return e.when([]);var c={method:"POST",url:this.url+"/api/v1/datapoints/query/tags",data:{metrics:[{name:a}],cache_time:0,start_absolute:0}};return f.datasourceRequest(c).then(function(a){return a.data?a.data.queries[0].results[0].tags[b]:e.when([])})},h.prototype.performTagSuggestQuery=function(a){var b={url:this.url+"/api/v1/datapoints/query/tags",method:"POST",data:{metrics:[{name:a}],cache_time:0,start_absolute:0}};return f.datasourceRequest(b).then(function(a){return a.data?a.data.queries[0].results[0]:[]})},h.prototype.metricFindQuery=function(a){if(!a)return e.when([]);var c;try{c=g.replace(a)}catch(d){return e.reject(d)}var f=function(a){return b.map(a,function(a){return{text:a}})},h=/metrics\((.*)\)/,i=/tag_names\((.*)\)/,j=/tag_values\((.*),\s?(.*?)\)/,k=c.match(h);if(k)return this._performMetricSuggestQuery(k[1]).then(f);var l=c.match(i);if(l)return this._performMetricKeyLookup(l[1]).then(f);var m=c.match(j);return m?this._performMetricKeyValueLookup(m[1],m[2]).then(f):e.when([])},h.prototype.convertToKairosInterval=function(a){a=g.replace(a);var b=/(\d+(?:\.\d+)?)([Mwdhmsy])/,c=/(\d+(?:\.\d+)?)(ms)/,e=a.match(c);if(e||(e=a.match(b)),!e)throw new Error('Invalid interval string, expecting a number followed by one of "y M w d h m s ms"');var f=e[1],h=e[2];if(f%1!==0){if("ms"===h)throw new Error("Invalid interval value, cannot be smaller than the millisecond");f=Math.round(d.intervals_in_seconds[h]*f*1e3),h="ms"}return{value:f,unit:m(h)}},h}])});