/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","app/core/utils/datemath","moment","./directives","./queryCtrl"],function(a,b,c){"use strict";var d=a.module("grafana.services");d.factory("OpenTSDBDatasource",["$q","backendSrv","templateSrv",function(d,e,f){function g(a){this.type="opentsdb",this.url=a.url,this.name=a.name,this.supportMetrics=!0}function h(a,c,d,e){var f=i(a,d,c,e),g=[];return b.each(a.dps,function(a,b){g.push([a,1e3*b])}),{target:f,datapoints:g}}function i(a,c,d,e){if(c.alias){var g=b.clone(e.scopedVars||{});return b.each(a.tags,function(a,b){g["tag_"+b]={value:a}}),f.replace(c.alias,g)}var h=a.metric,i=[];return b.isEmpty(a.tags)||b.each(b.pairs(a.tags),function(a){b.has(d,a[0])&&i.push(a[0]+"="+a[1])}),b.isEmpty(i)||(h+="{"+i.join(", ")+"}"),h}function j(b,c){if(!b.metric||b.hide)return null;var d={metric:f.replace(b.metric,c.scopedVars),aggregator:"avg"};if(b.aggregator&&(d.aggregator=f.replace(b.aggregator)),b.shouldComputeRate&&(d.rate=!0,d.rateOptions={counter:!!b.isCounter},b.counterMax&&b.counterMax.length&&(d.rateOptions.counterMax=parseInt(b.counterMax)),b.counterResetValue&&b.counterResetValue.length&&(d.rateOptions.resetValue=parseInt(b.counterResetValue))),!b.disableDownsampling){var e=f.replace(b.downsampleInterval||c.interval);e.match(/\.[0-9]+s/)&&(e=1e3*parseFloat(e)+"ms"),d.downsample=e+"-"+b.downsampleAggregator}if(d.tags=a.copy(b.tags),d.tags)for(var g in d.tags)d.tags[g]=f.replace(d.tags[g],c.scopedVars);return d}function k(a,c){var d;return b.map(a,function(a){return b.findIndex(c.targets,function(e){return e.metric===a.metric&&b.all(e.tags,function(b,e){return d=f.replace(b,c.scopedVars),a.tags[e]===d||"*"===d})})})}function l(a,b){return"now"===a?null:(a=c.parse(a,b),a.valueOf())}g.prototype.query=function(a){var c=l(a.rangeRaw.from,!1),e=l(a.rangeRaw.to,!0),f=[];b.each(a.targets,function(b){b.metric&&f.push(j(b,a))});var g=b.compact(f);if(b.isEmpty(g)){var i=d.defer();return i.resolve({data:[]}),i.promise}var m={};return b.each(g,function(a){b.each(a.tags,function(a,b){m[b]=!0})}),this.performTimeSeriesQuery(g,c,e).then(function(c){var d=k(c.data,a),e=b.map(c.data,function(b,c){return c=d[c],-1===c&&(c=0),h(b,m,a.targets[c],a)});return{data:e}})},g.prototype.performTimeSeriesQuery=function(a,b,c){var d={start:b,queries:a};c&&(d.end=c);var f={method:"POST",url:this.url+"/api/query",data:d};return e.datasourceRequest(f)},g.prototype._performSuggestQuery=function(a,b){return this._get("/api/suggest",{type:b,q:a,max:1e3}).then(function(a){return a.data})},g.prototype._performMetricKeyValueLookup=function(a,c){if(!a||!c)return d.when([]);var e=a+"{"+c+"=*}";return this._get("/api/search/lookup",{m:e,limit:3e3}).then(function(a){a=a.data.results;var d=[];return b.each(a,function(a){-1===d.indexOf(a.tags[c])&&d.push(a.tags[c])}),d})},g.prototype._performMetricKeyLookup=function(a){return a?this._get("/api/search/lookup",{m:a,limit:1e3}).then(function(a){a=a.data.results;var c=[];return b.each(a,function(a){b.each(a.tags,function(a,b){-1===c.indexOf(b)&&c.push(b)})}),c}):d.when([])},g.prototype._get=function(a,b){return e.datasourceRequest({method:"GET",url:this.url+a,params:b})},g.prototype.metricFindQuery=function(a){if(!a)return d.when([]);var c;try{c=f.replace(a)}catch(e){return d.reject(e)}var g=function(a){return b.map(a,function(a){return{text:a}})},h=/metrics\((.*)\)/,i=/tag_names\((.*)\)/,j=/tag_values\((.*),\s?(.*)\)/,k=/suggest_tagk\((.*)\)/,l=/suggest_tagv\((.*)\)/,m=c.match(h);if(m)return this._performSuggestQuery(m[1],"metrics").then(g);var n=c.match(i);if(n)return this._performMetricKeyLookup(n[1]).then(g);var o=c.match(j);if(o)return this._performMetricKeyValueLookup(o[1],o[2]).then(g);var p=c.match(k);if(p)return this._performSuggestQuery(p[1],"tagk").then(g);var q=c.match(l);return q?this._performSuggestQuery(q[1],"tagv").then(g):d.when([])},g.prototype.testDatasource=function(){return this._performSuggestQuery("cpu","metrics").then(function(){return{status:"success",message:"Data source is working",title:"Success"}})};var m=null;return g.prototype.getAggregators=function(){return m?m:m=this._get("/api/aggregators").then(function(a){return a.data&&b.isArray(a.data)?a.data.sort():[]})},g}])});