/*! grafana - v2.6.0 - 2015-12-14
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","moment","app/core/utils/datemath","./directives","./query_ctrl"],function(a,b,c,d){"use strict";var e=a.module("grafana.services"),f=/(\d+)(ms|s|m|h|d|w|M|y)/;e.factory("PrometheusDatasource",["$q","backendSrv","templateSrv",function(a,e,g){function h(a){this.type="prometheus",this.editorSrc="app/features/prometheus/partials/query.editor.html",this.name=a.name,this.supportMetrics=!0,this.url=a.url,this.directUrl=a.directUrl,this.basicAuth=a.basicAuth,this.withCredentials=a.withCredentials,this.lastErrors={}}function i(a,c){var d=[],e=null;e=j(a.metric,c);var f=1e3*parseInt(c.step),g=null;return b.each(a.values,function(a){var c=parseFloat(a[1]);b.isNaN(c)&&(c=null);var e=1e3*a[0];g&&e-g>f&&d.push([null,g+f]),g=e,d.push([c,e])}),{target:e,datapoints:d}}function j(a,c){if(b.isUndefined(c)||b.isEmpty(c.legendFormat))return k(a);var d=b.templateSettings;b.templateSettings={interpolate:/\{\{(.+?)\}\}/g};var e,f=b.template(g.replace(c.legendFormat));try{e=f(a)}catch(h){e="{}"}return b.templateSettings=d,e}function k(a){var c=a.__name__||"";delete a.__name__;var d=b.map(b.pairs(a),function(a){return a[0]+'="'+a[1]+'"'}).join(",");return c+"{"+d+"}"}function l(a,c){return b.isString(a)&&(a=d.parse(a,c)),(a.valueOf()/1e3).toFixed(0)}return h.prototype._request=function(a,b){var c={url:this.url+b,method:a};return(this.basicAuth||this.withCredentials)&&(c.withCredentials=!0),this.basicAuth&&(c.headers={Authorization:this.basicAuth}),e.datasourceRequest(c)},h.prototype.query=function(c){var d=l(c.range.from,!1),e=l(c.range.to,!0),f=[];if(c=b.clone(c),b.each(c.targets,b.bind(function(a){if(a.expr&&!a.hide){var b={};b.expr=g.replace(a.expr,c.scopedVars);var h=a.interval||c.interval,i=a.intervalFactor||1;a.step=b.step=this.calculateInterval(h,i);var j=Math.ceil(e-d);0!==b.step&&j/b.step>11e3&&(a.step=b.step=Math.ceil(j/11e3)),f.push(b)}},this)),b.isEmpty(f)){var h=a.defer();return h.resolve({data:[]}),h.promise}var j=b.map(f,b.bind(function(a){return this.performTimeSeriesQuery(a,d,e)},this)),k=this;return a.all(j).then(function(a){var d=[];return b.each(a,function(a,e){if("error"===a.status)throw k.lastErrors.query=a.error,a.error;delete k.lastErrors.query,b.each(a.data.data.result,function(a){d.push(i(a,c.targets[e]))})}),{data:d}})},h.prototype.performTimeSeriesQuery=function(a,b,c){var d="/api/v1/query_range?query="+encodeURIComponent(a.expr)+"&start="+b+"&end="+c+"&step="+a.step;return this._request("GET",d)},h.prototype.performSuggestQuery=function(a){var c="/api/v1/label/__name__/values";return this._request("GET",c).then(function(c){return b.filter(c.data.data,function(b){return 1!==b.indexOf(a)})})},h.prototype.metricFindQuery=function(c){if(!c)return a.when([]);var d;try{d=g.replace(c)}catch(e){return a.reject(e)}var f,h=/^label_values\(([^,]+)(?:,\s*(.+))?\)$/,i=/^metrics\((.+)\)$/,j=d.match(h);if(j)return j[2]?(f="/api/v1/series?match[]="+encodeURIComponent(j[1]),this._request("GET",f).then(function(a){return b.map(a.data.data,function(a){return{text:a[j[2]],expandable:!0}})})):(f="/api/v1/label/"+j[1]+"/values",this._request("GET",f).then(function(a){return b.map(a.data.data,function(a){return{text:a}})}));var l=d.match(i);return l?(f="/api/v1/label/__name__/values",this._request("GET",f).then(function(a){return b.chain(a.data.data).filter(function(a){var b=new RegExp(l[1]);return b.test(a)}).map(function(a){return{text:a,expandable:!0}}).value()})):(f="/api/v1/series?match[]="+encodeURIComponent(d),this._request("GET",f).then(function(a){return b.map(a.data.data,function(a){return{text:k(a),expandable:!0}})}))},h.prototype.testDatasource=function(){return this.metricFindQuery("metrics(.*)").then(function(){return{status:"success",message:"Data source is working",title:"Success"}})},h.prototype.calculateInterval=function(a,b){var d=a.match(f),e=c.duration(parseInt(d[1]),d[2]),g=e.asSeconds();return 1>g&&(g=1),Math.ceil(g*b)},h}])});